--
-- RegisterAgribumperSpecialization
-- register the agribumper specialization
--
-- @author John Deere 6930
-- @date 23/01/2019
--

RegisterAgribumperSpecialization = {};
RegisterAgribumperSpecialization.modDir = g_currentModDirectory;
RegisterAgribumperSpecialization.register = false;
RegisterAgribumperSpecialization.requiredSpecializations = {Drivable, Lights, AttacherJoints};



function RegisterAgribumperSpecialization:addSpecializationToVehicleTypes(name, requiredSpecializations)
	for vehicleType, vehicle in pairs(g_vehicleTypeManager.vehicleTypes) do
		if vehicle ~= nil then
			local allowInsertion = true;			
			for _, rqspec in pairs(requiredSpecializations) do
				allowInsertion = SpecializationUtil.hasSpecialization(rqspec, vehicle.specializations);
				if not allowInsertion then
					break;
				end;
			end;
			
			if allowInsertion then
				local spec = g_specializationManager:getSpecializationObjectByName(name);				
				vehicle.specializationsByName[name] = spec;
				table.insert(vehicle.specializationNames, name);
				table.insert(vehicle.specializations, spec);
			end;
		end;
	end;
end;

if RegisterAgribumperSpecialization.register == false then
	if g_specializationManager:getSpecializationByName("agribumper") == nil then
		local filename = Utils.getFilename("scripts/Agribumper.lua", RegisterAgribumperSpecialization.modDir);
		RegisterAgribumperSpecialization.register = g_specializationManager:addSpecialization("agribumper", "Agribumper", filename, true, nil);
		
		RegisterAgribumperSpecialization:addSpecializationToVehicleTypes("agribumper", RegisterAgribumperSpecialization.requiredSpecializations);
	end;
end;

